SystemOrganization addCategory: #'Parasol-Convenience'!

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
contextClick
	
	(BPActions driver: driver)
		contextClick: self;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
contextClickAt: aPoint
	
	(BPActions driver: driver)
		contextClick: self at: aPoint;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 12/11/2012 14:57'!
cssClassNames

	^ (Character space split: ((self getAttribute: 'class') ifNil: [ #() ])) select: [ :className | className isEmpty not ]! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
doubleClick
	
	(BPActions driver: driver)
		doubleClick: self;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'ThomasCleenewerck 5/30/2013 11:42'!
getDirectTextIngoreTextInDescandants
	| children text |
	children := self findElementsByXPath: '*'.
	text := self getText.
	"elements can occur before the text nodes and after one, hence we cannot simply trim from the start nor from the rear"
	children do: [ :c | text := text copyReplaceAll: c getText with: '' ].
	^text trimBoth  ! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 7/9/2012 15:10'!
sendKey: character

	^ self sendKeys: (String with: character)! !

!BPKeyboard methodsFor: '*parasol-convenience' stamp: 'JohanBrichau 2/28/2014 17:18'!
releaseModifierKeys
	self sendKeys: (String with: BPKeys null) ! !

!BPKeyboard methodsFor: '*parasol-convenience' stamp: 'JohanBrichau 1/21/2013 14:49'!
sendAltKey
	self sendKeys: (BPKeys alt) asString! !

!BPRemoteWebDriver methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 10/10/2012 11:31'!
openAndSwitchToNewWindow

	| handle |
	handle := self openNewWindow.
	self switchTo window: handle.
	^ handle! !

!BPRemoteWebDriver methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 10/10/2012 11:31'!
openNewWindow

	self executeScript: 'window.open()' with: #(). 
	^ self getWindowHandles last.! !

!BPActions methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 7/9/2012 14:48'!
contextClick: webElement at: aPoint
	
	self moveToElement: webElement offset: aPoint.
	action addAction: (BPClickAction driver: driver buttonNumber: 2).! !

!BPActions methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:17'!
drag: sourceWebElement andDrop: targetWebElement at: aPoint

	self
		clickAndHold: sourceWebElement;
		moveToElement: targetWebElement offset: aPoint;
		releaseButton! !
